Public Class ClassLogger

    Private Shared DateiSpeicherort As String = Nothing
    Private Shared DateiPrefix As String = ""
    Private Shared Datei As IO.File = Nothing
    Private Shared Dateiname As String = ""
    Private Shared StreamWriter As IO.StreamWriter = Nothing
    Private Shared _Helper As New ClassHelper
    Private Shared HasInformedAboutError As Boolean = False

    ' eine Art Konstruktor
    Public Shared Sub Init(ByVal speicherort As String, Optional ByVal prefix As String = "", Optional ByVal appendFile As Boolean = True)

        ' initialisiert den Speicherort
        ClassLogger.SetSpeicherort(speicherort)

        ' wenn ein Prfix gesetzt wurde
        If Not prefix = "" Then

            ' initialisiert das Prefix
            ClassLogger.SetPrefix(prefix)
        End If

        ClassLogger.Dateiname = ClassLogger.DateiSpeicherort & "\" & ClassLogger.DateiPrefix & System.DateTime.Now.ToString("yyyy_MM_dd") & ".txt"
        If _Helper.FileExists(ClassLogger.DateiSpeicherort & "\" & ClassLogger.DateiPrefix & System.DateTime.Now.ToString("yyyy_MM_dd") & ".txt") = False Then
            My.Computer.FileSystem.WriteAllText(ClassLogger.Dateiname, String.Empty, False)
        End If

        If Not appendFile Then
            ' der Versuch die Datei zu löschen
            'Try
            '    My.Computer.FileSystem.DeleteFile(ClassNILogger.Dateiname, FileIO.UIOption.OnlyErrorDialogs, FileIO.RecycleOption.DeletePermanently)
            'Catch ex As Exception
            '    ' bei Fehler besteht kein Schreibrecht auf die Datei oder Datei existiert nicht
            '    ' ALSO: alles Okay soweit
            'End Try


        End If
        ' testen ob sich die Datei öffnen und beschreiben lässt
        ClassLogger.CheckIsLogWritable()

    End Sub

    ' legt den Speicherort fest
    Public Shared Sub SetSpeicherort(ByVal speicherort As String)
        Dim _dir As New IO.DirectoryInfo(My.Application.Info.DirectoryPath & "\Log")
        If speicherort = "" Then
            If _dir.Exists = False Then
                IO.Directory.CreateDirectory(My.Application.Info.DirectoryPath & "\Log")
            End If
            ClassLogger.DateiSpeicherort = My.Application.Info.DirectoryPath & "\Log\"
        Else
            ClassLogger.DateiSpeicherort = speicherort
        End If
    End Sub

    ' legt das Prefix für den Dateinamen fest
    Public Shared Sub SetPrefix(ByVal prefix As String)
        ClassLogger.DateiPrefix = prefix
    End Sub

    Public Shared Sub Add(ByVal information As String, Optional ByVal mit_prefix As Boolean = True)
        If ClassLogger.OpenFile Then
            Try
                If mit_prefix Then
                    ClassLogger.StreamWriter.WriteLine("Nachricht (" & System.DateTime.Now & "): " & information)
                Else
                    ClassLogger.StreamWriter.WriteLine(information)
                End If
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
            End Try
        Else
            ClassLogger.ShowErrorMessage()
        End If
    End Sub

    Public Shared Sub Add(ByVal ClassFunction As String, ByVal information As String)
        If ClassLogger.OpenFile Then
            Try
                ClassLogger.StreamWriter.WriteLine("Exception (" & System.DateTime.Now & "): " & ClassFunction & " => " & information)
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
            End Try
        Else
            ClassLogger.ShowErrorMessage()
        End If
    End Sub

    Public Shared Sub Add(ByVal ex As Exception)
        If ClassLogger.OpenFile Then
            Try
                ClassLogger.StreamWriter.WriteLine("Exception (" & System.DateTime.Now & "): " & ex.Message & " [" & ex.Source & "]")
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
            End Try
        Else
            ClassLogger.ShowErrorMessage()
        End If
    End Sub

    'Public Shared Sub Add(ByVal ex As Oracle.DataAccess.Client.OracleException)
    '    If ClassLogger.OpenFile Then
    '        Try
    '            ClassLogger.StreamWriter.WriteLine("OracleException (" & System.DateTime.Now & "): " & ex.Message & " [" & ex.Source & "][" & ex.ErrorCode & "]")
    '            ClassLogger.CloseFile()
    '        Catch e As Exception
    '            ClassLogger.ShowErrorMessage()
    '        End Try
    '    Else
    '        ClassLogger.ShowErrorMessage()
    '    End If
    'End Sub

    Public Shared Sub Add(ByVal ClassFunction As String, ByVal ex As Exception)
        If ClassLogger.OpenFile Then
            Try
                ClassLogger.StreamWriter.WriteLine("Exception (" & System.DateTime.Now & "): " & ex.Message & " [" & ex.Source & "] => " & ClassFunction)
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
            End Try
        Else
            ClassLogger.ShowErrorMessage()
        End If
    End Sub

    'Public Shared Sub Add(ByVal ClassFunction As String, ByVal ex As Oracle.DataAccess.Client.OracleException)
    '    If ClassLogger.OpenFile Then
    '        Try
    '            ClassLogger.StreamWriter.WriteLine("OracleException (" & System.DateTime.Now & "): " & ex.Message & " [" & ex.Source & "][" & ex.ErrorCode & "] => " & ClassFunction)
    '            ClassLogger.CloseFile()
    '        Catch e As Exception
    '            ClassLogger.ShowErrorMessage()
    '        End Try
    '    Else
    '        ClassLogger.ShowErrorMessage()
    '    End If
    'End Sub

    Public Shared Sub Add(ByVal ClassFunction As String, ByVal information As String, ByVal ex As Exception)

        If ClassLogger.OpenFile Then
            Try
                ClassLogger.StreamWriter.WriteLine("Exception (" & System.DateTime.Now & "): " & ex.Message & " [" & ex.Source & "] => " & ClassFunction & " => " & information)
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
            End Try
        Else
            ClassLogger.ShowErrorMessage()
        End If

    End Sub

    ' öffnet eine Datei zum Schreiben
    Private Shared Function OpenFile()

        Try

            ' wenn ein Speicherort festgelegt wurde
            If Not ClassLogger.DateiSpeicherort = Nothing Then

                ' den Dateienamen definieren
                Dim dateiname As String = ClassLogger.Dateiname

                ' Datei anlegen wenn noch nicht vorhanden
                My.Computer.FileSystem.WriteAllText(dateiname, String.Empty, True)

                ' die Datei zum Schreiben öffnen
                ClassLogger.StreamWriter = New IO.StreamWriter(dateiname, True, System.Text.Encoding.UTF8)
            End If

            ' wenn die Datei erfolgreich geöffnet wurde
            If ClassLogger.StreamWriter IsNot Nothing Then
                Return True
            Else
                Return False
            End If

        Catch ex As Exception
            Return False
        End Try

    End Function

    ' öffnet eine Datei zum Schreiben
    Private Shared Function OpenFile(ByVal DateiSpeicherort As String, ByVal DateiPrefix As String)

        Try

            ' wenn ein Speicherort festgelegt wurde
            If Not DateiSpeicherort = Nothing And ClassLogger.CheckIsLogWritable() Then

                ' den Dateienamen definieren
                Dim dateiname As String = ClassLogger.Dateiname
                ' Datei anlegen wenn noch nicht vorhanden
                My.Computer.FileSystem.WriteAllText(dateiname, String.Empty, True)

                ' die Datei zum Schreiben öffnen
                ClassLogger.StreamWriter = New IO.StreamWriter(dateiname, True, System.Text.Encoding.UTF8)
            End If

            ' wenn die Datei erfolgreich geöffnet wurde
            If ClassLogger.StreamWriter IsNot Nothing Then
                Return True
            Else
                Return False
            End If

        Catch ex As Exception
            Return False
        End Try

    End Function


    ' schliesst die geöffnete Datei
    Private Shared Sub CloseFile()

        ' wenn eine Datei geöffnet ist
        If ClassLogger.StreamWriter IsNot Nothing Then
            ' die Datei schliessen
            ClassLogger.StreamWriter.Close()
            ClassLogger.StreamWriter = Nothing
        End If
    End Sub


    Public Shared Function CheckIsLogWritable()

        If ClassLogger.OpenFile Then
            Try
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
                Return False
            End Try
        Else
            ClassLogger.ShowErrorMessage()
            Return False
        End If

        Return True
    End Function


    Public Shared Function CheckIsLogWritable(ByVal vDateiSpeicherort As String, ByVal vDateiPrefix As String)

        If ClassLogger.OpenFile(vDateiSpeicherort, vDateiPrefix) Then
            Try
                ClassLogger.CloseFile()
            Catch e As Exception
                ClassLogger.ShowErrorMessage()
                Return False
            End Try
        Else
            ClassLogger.ShowErrorMessage()
            Return False
        End If

        Return True
    End Function
    Private Shared Sub ShowErrorMessage()
        If Not ClassLogger.HasInformedAboutError Then
            ' MsgBox("Beim Öffnen der Logdatei ist ein Fehler aufgetreten. Bitte stellen Sie sicher das Sie sowohl über entsprechende Schreibrechte im Verzeichnis, als auch über ausreichend Speicherplatz zum Speichern der Logdatei verfügen." & vbNewLine & vbNewLine & "Es wird keine Logdatei angelegt oder beschrieben." & vbNewLine & vbNewLine & "Im folgenden werden Sie über Fehler, den Log betreffend nicht weiter informiert, um den Ablauf der Nachindexierung nicht zu stören.", MsgBoxStyle.Information, "Fehler beim Öffnen der Logdatei")
            ClassLogger.HasInformedAboutError = True
        End If
    End Sub


End Class
